#!/usr/bin/env bash
set -eu
{% from 'macros.jinja' import repository %}
{% if with_WORKSPACE %}
default_workspace_dir()
{
  local repo_dir=
  repo_dir="$(git rev-parse --show-toplevel)"
  local parent_repo_dir=
  parent_repo_dir=$(dirname "${repo_dir}")
  if [[ $(basename "${parent_repo_dir}") == *"workspace"* ]]; then
    echo "${parent_repo_dir}"
  else
    echo "${parent_repo_dir}/workspace"
  fi
}
{% endif %}
on_exit()
{
  rm -f "$DOCKERFILE_DIR/containerId"
}
trap on_exit EXIT

DOCKERFILE_DIR=$(cd "$(dirname "${BASH_SOURCE[0]}")/.." &> /dev/null && pwd)
TAG=
TAG=$(cat "$DOCKERFILE_DIR"/tag)

export_user=( -e USERNAME="$(whoami)" -e USER_ID="$(id -u)" -e GROUP_ID="$(id -g)" --userns=host )

IFS=" " read -r -a export_variables <<< "${EXPORT_VARIABLES:-}"
IFS=" " read -r -a map_directories <<< "${MAP_DIRECTORIES:-}"
export_variables+=( -e DOCKER_IMAGE_TAG="${TAG}" )

{% if with_current_repo_mapped %}map_directories+=( -v "$(git rev-parse --show-toplevel)":"$(git rev-parse --show-toplevel)" ){% endif %}
{% if with_WORKSPACE %}
# Mount $WORKSPACE directory or create one in parent directory
if [ ! -v WORKSPACE ]; then
  export WORKSPACE=
  WORKSPACE=$(default_workspace_dir)
fi
mkdir -p "${WORKSPACE:-}"
WORKSPACE=$(cd "${WORKSPACE:-}"; pwd)
export_variables+=( -e WORKSPACE="${WORKSPACE:-}" )
map_directories+=( -v "${WORKSPACE:-}":"${WORKSPACE:-}" )
{% endif %}

set -x
docker run "${export_user[@]}" "${export_variables[@]}" "${map_directories[@]}" --cidfile="$DOCKERFILE_DIR"/containerId -it {% if run_privileged %}--privileged{% endif %} {% if run_net_host %}--network host{% endif %}  --rm {{repository(registry, group, name)}}:"${TAG}" "$@"
set +x
